//+-----------------------------------------------------------------------------------+
//                                                        DMETimePriceZonesv2c.mq4    |
//  v2   enter your chart times where you want to see the zones, not GMT offsert      |
//  v2a  fixed problem with a zone spanning a day change                              |                     
//       added user control over eash session's line color                            |
//  v2b  added code to restict updating graphics to only at bar close                 |
//         after objects created for the first time, saves resources                  |
//  v2c  fixed bug, session 2 inner zone line was not painting due to typo            |
//+-----------------------------------------------------------------------------------+
#property indicator_chart_window
 
extern int    LookBackDays = 10;        
extern int    ZoneExtPips    = 10;
extern string _Zones_Appear_At = "Enter your chart times";
extern string Ses1Beg       = "08:00";   
extern string Ses1End       = "09:59";   
extern color  Ses1Color     = C'230,230,230';
extern color  Ses1EColor    = C'185,185,185'; 
extern color  Ses1LineColor = C'000,165,000';
extern string Ses2Beg       = "14:00";   
extern string Ses2End       = "15:59";   
extern color  Ses2Color     = C'230,230,230';        
extern color  Ses2EColor    = C'185,185,185';
extern color  Ses2LineColor = C'000,165,000';
extern string Ses3Beg       = "19:00";   
extern string Ses3End       = "20:59";   
extern color  Ses3Color     = C'230,230,230';                     
extern color  Ses3EColor    = C'185,185,185';
extern color  Ses3LineColor = C'000,165,000';
extern string Ses4Beg       = "00:00";   
extern string Ses4End       = "01:59";   
extern color  Ses4Color     = C'230,230,230'; 
extern color  Ses4EColor    = C'185,185,185';
extern color  Ses4LineColor = C'000,165,000';
extern int    LineWidth     = 1;
extern int    LineStyle     = 0;
extern bool   ShowInnerLine = false;
extern string DayEnd        = "07:59";   

double ZoneExtPrice;
datetime  LastBarTime;
int AddDay;
bool FirstTimeDone;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
  ZoneExtPrice = ZoneExtPips * Point;
  FirstTimeDone = false;    
  DeleteObjects();
  LastBarTime = iTime(NULL, 0, 1);
  
  for (int i = 0; i < LookBackDays; i++) {
    CreateObjects("Ses1"+i, "Ses1L"+i, "Ses1H"+i, "Ses1LL"+i, "Ses1HL"+i, "Ses1ILL"+i, "Ses1IHL"+i, Ses1Color, Ses1EColor, Ses1LineColor);
    CreateObjects("Ses2"+i, "Ses2L"+i, "Ses2H"+i, "Ses2LL"+i, "Ses2HL"+i, "Ses2ILL"+i, "Ses2IHL"+i, Ses2Color, Ses2EColor, Ses2LineColor);
    CreateObjects("Ses3"+i, "Ses3L"+i, "Ses3H"+i, "Ses3LL"+i, "Ses3HL"+i, "Ses3ILL"+i, "Ses3IHL"+i, Ses3Color, Ses3EColor, Ses3LineColor);
    CreateObjects("Ses4"+i, "Ses4L"+i, "Ses4H"+i, "Ses4LL"+i, "Ses4HL"+i, "Ses4ILL"+i, "Ses4IHL"+i, Ses4Color, Ses4EColor, Ses4LineColor);
  }
}

void deinit() {   DeleteObjects();   }

void CreateObjects(string Ses, string SesL, string SesH, string SesLL, string SesHL, string SesILL, string SesIHL, color SesColor, color SesEColor,color LineColor) {
  ObjectCreate(Ses, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
  ObjectSet(Ses, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet(Ses, OBJPROP_COLOR, SesColor);
  ObjectSet(Ses, OBJPROP_BACK, True);
 
  ObjectCreate(SesL, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
  ObjectSet(SesL, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet(SesL, OBJPROP_COLOR, SesEColor);
  ObjectSet(SesL, OBJPROP_BACK, True);
  
  ObjectCreate(SesH, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
  ObjectSet(SesH, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet(SesH, OBJPROP_COLOR, SesEColor);
  ObjectSet(SesH, OBJPROP_BACK, True);
  
  ObjectCreate(SesLL, OBJ_TREND, 0, 0, 0, 0, 0);    
  ObjectSet(SesLL, OBJPROP_COLOR, LineColor);
  ObjectSet(SesLL, OBJPROP_BACK, True);  
  ObjectSet(SesLL, OBJPROP_WIDTH, LineWidth);
  ObjectSet(SesLL, OBJPROP_STYLE, LineStyle);
    
  ObjectCreate(SesHL, OBJ_TREND, 0, 0, 0, 0, 0);    
  ObjectSet(SesHL, OBJPROP_COLOR, LineColor);
  ObjectSet(SesHL, OBJPROP_BACK, True);
  ObjectSet(SesHL, OBJPROP_WIDTH, LineWidth);
  ObjectSet(SesHL, OBJPROP_STYLE, LineStyle);
  
  
  if(ShowInnerLine)   {
      ObjectCreate(SesILL, OBJ_TREND, 0, 0, 0, 0, 0);    
      ObjectSet(SesILL, OBJPROP_COLOR, LineColor);
      ObjectSet(SesILL, OBJPROP_BACK, True);  
      ObjectSet(SesILL, OBJPROP_WIDTH, LineWidth);
      ObjectSet(SesILL, OBJPROP_STYLE, LineStyle);
    
      ObjectCreate(SesIHL, OBJ_TREND, 0, 0, 0, 0, 0);    
      ObjectSet(SesIHL, OBJPROP_COLOR, LineColor);
      ObjectSet(SesIHL, OBJPROP_BACK, True);
      ObjectSet(SesIHL, OBJPROP_WIDTH, LineWidth);
      ObjectSet(SesIHL, OBJPROP_STYLE, LineStyle);
   }   
}

void DeleteObjects() {
  for (int i = 0; i < LookBackDays; i++) {
    ObjectDelete("Ses1"+i);
    ObjectDelete("Ses2"+i);
    ObjectDelete("Ses3"+i);
    ObjectDelete("Ses4"+i);
    ObjectDelete("Ses1L"+i);
    ObjectDelete("Ses2L"+i);
    ObjectDelete("Ses3L"+i);
    ObjectDelete("Ses4L"+i);
    ObjectDelete("Ses1H"+i);
    ObjectDelete("Ses2H"+i);
    ObjectDelete("Ses3H"+i);
    ObjectDelete("Ses4H"+i);
    
    ObjectDelete("Ses1LL"+i);
    ObjectDelete("Ses1HL"+i); 
    ObjectDelete("Ses2LL"+i);
    ObjectDelete("Ses2HL"+i); 
    ObjectDelete("Ses3LL"+i);
    ObjectDelete("Ses3HL"+i); 
    ObjectDelete("Ses4LL"+i);
    ObjectDelete("Ses4HL"+i); 
    
    if(ShowInnerLine)   {     
      ObjectDelete("Ses1ILL"+i);
      ObjectDelete("Ses1IHL"+i); 
      ObjectDelete("Ses2ILL"+i);
      ObjectDelete("Ses2IHL"+i); 
      ObjectDelete("Ses3ILL"+i);
      ObjectDelete("Ses3IHL"+i); 
      ObjectDelete("Ses4ILL"+i);
      ObjectDelete("Ses4IHL"+i);
    }   
  }
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {
  datetime dateNtime = TimeCurrent();
   
 if((FirstTimeDone == false) || (FirstTimeDone == true && iTime(NULL, 0, 0) > LastBarTime)) {       // should only paint once per bar close
   
    for (int i = 0; i < LookBackDays; i++) { 
    
      LastBarTime = iTime(NULL, 0, 0);    
      DrawObjects(dateNtime, "Ses1"+i, "Ses1L"+i, "Ses1H"+i, "Ses1LL"+i, "Ses1HL"+i, "Ses1ILL"+i, "Ses1IHL"+i,  Ses1Beg, Ses1End, DayEnd);
      DrawObjects(dateNtime, "Ses2"+i, "Ses2L"+i, "Ses2H"+i, "Ses2LL"+i, "Ses2HL"+i, "Ses2ILL"+i, "Ses2IHL"+i,  Ses2Beg, Ses2End, DayEnd);
      DrawObjects(dateNtime, "Ses3"+i, "Ses3L"+i, "Ses3H"+i, "Ses3LL"+i, "Ses3HL"+i, "Ses3ILL"+i, "Ses3IHL"+i,  Ses3Beg, Ses3End, DayEnd);
      DrawObjects(dateNtime, "Ses4"+i, "Ses4L"+i, "Ses4H"+i, "Ses4LL"+i, "Ses4HL"+i, "Ses4ILL"+i, "Ses4IHL"+i,  Ses4Beg, Ses4End, DayEnd);   
      AddDay = 0; 
      dateNtime = decDateTradeDay(dateNtime, AddDay);
      FirstTimeDone = true;
   }
  }
}

  
void DrawObjects(datetime dateNtime, string Ses, string SesL, string SesH, string SesLL, string SesHL, string SesILL, string SesIHL, string tb, string te, string de) {
  datetime t1, t2, t3;
  double   p1, p2;
  int      b1, b2;

  t1=StrToTime(TimeToStr(dateNtime, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dateNtime, TIME_DATE)+" "+te);
  t3=StrToTime(TimeToStr(dateNtime, TIME_DATE)+" "+de);
  if(t2 < t1) {    t2 = t2 + 86400;       }     
  if(t3 < t2) {    t3 = t3 + 86400;       }     
  
  b1=iBarShift(NULL, 0, t1,true);
  b2=iBarShift(NULL, 0, t2);
  if (b1 == -1)  {  t1 = 0; t2 = 0; t3 = 0;  }
  
  p1=High[iHighest(NULL, 0, MODE_HIGH, b1-b2, b2)];
  p2=Low [iLowest (NULL, 0, MODE_LOW , b1-b2, b2)];
  
  ObjectSet(Ses, OBJPROP_TIME1 , t1);
  ObjectSet(Ses, OBJPROP_PRICE1, p1);
  ObjectSet(Ses, OBJPROP_TIME2 , t2);
  ObjectSet(Ses, OBJPROP_PRICE2, p2);
  
  ObjectSet(SesL, OBJPROP_TIME1 , t1);
  ObjectSet(SesL, OBJPROP_PRICE1, p2);
  ObjectSet(SesL, OBJPROP_TIME2 , t2);
  ObjectSet(SesL, OBJPROP_PRICE2, p2 - ZoneExtPrice);
  
  ObjectSet(SesH, OBJPROP_TIME1 , t1);
  ObjectSet(SesH, OBJPROP_PRICE1, p1);
  ObjectSet(SesH, OBJPROP_TIME2 , t2);
  ObjectSet(SesH, OBJPROP_PRICE2, p1 + ZoneExtPrice);
  
  ObjectSet(SesLL, OBJPROP_TIME1 , t1);
  ObjectSet(SesLL, OBJPROP_PRICE1, p2 - ZoneExtPrice);
  ObjectSet(SesLL, OBJPROP_TIME2 , t3);
  ObjectSet(SesLL, OBJPROP_PRICE2, p2 - ZoneExtPrice);
  ObjectSet(SesLL, OBJPROP_RAY, false);
     
  ObjectSet(SesHL, OBJPROP_TIME1 , t1);
  ObjectSet(SesHL, OBJPROP_PRICE1, p1 + ZoneExtPrice);
  ObjectSet(SesHL, OBJPROP_TIME2 , t3);
  ObjectSet(SesHL, OBJPROP_PRICE2, p1 + ZoneExtPrice);
  ObjectSet(SesHL, OBJPROP_RAY, false);
     
  if(ShowInnerLine)   {
     ObjectSet(SesILL, OBJPROP_TIME1 , t1);
     ObjectSet(SesILL, OBJPROP_PRICE1, p2);
     ObjectSet(SesILL, OBJPROP_TIME2 , t3);
     ObjectSet(SesILL, OBJPROP_PRICE2, p2);
     ObjectSet(SesILL, OBJPROP_RAY, false);
     
     ObjectSet(SesIHL, OBJPROP_TIME1 , t1);
     ObjectSet(SesIHL, OBJPROP_PRICE1, p1);
     ObjectSet(SesIHL, OBJPROP_TIME2 , t3);
     ObjectSet(SesIHL, OBJPROP_PRICE2, p1);
     ObjectSet(SesIHL, OBJPROP_RAY, false);
  }  
}


datetime decDateTradeDay (datetime dateNtime, int AddDay) {
  int ty=TimeYear(dateNtime);
  int tm=TimeMonth(dateNtime);
  int td=TimeDay(dateNtime);
  int th=TimeHour(dateNtime);
  int ti=TimeMinute(dateNtime);

  td--;
  if (td==0) {
    tm--;
    if (tm==0) {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  if (AddDay > 0)  td = td+1;
  return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}
//+------------------------------------------------------------------+

